"use strict";

function index(babel) {
  const template = babel.template;
  let exportDefaultDeclarationName = "";
  return {
    visitor: {
      Program: {
        enter(path) {
          path.scope.hasBinding("ReactDOM") || path.scope.hasBinding("React") && path.unshiftContainer("body", template.ast('import ReactDOM from "react-dom";'));
        },
        exit(path, state) {
          if (!path.scope.hasBinding("React")) return;
          if ("" === exportDefaultDeclarationName) return;
          const {opts: {root: root = "app", hydrate: hydrate = !1}} = state;
          path.pushContainer("body", template.ast(`if (typeof getStaticProps !== "undefined") {\n                (async function () {\n                  const data = await getStaticProps();\n                  ReactDOM.${hydrate ? "hydrate" : "render"}(React.createElement(${exportDefaultDeclarationName}, data.props), document.getElementById("${root}"));\n                })();\n              } else {\n                ReactDOM.${hydrate ? "hydrate" : "render"}(React.createElement(${exportDefaultDeclarationName}), document.getElementById("${root}"));\n              }`));
        }
      },
      ExportDefaultDeclaration: {
        enter(path) {
          if ("FunctionDeclaration" !== path.node.declaration.type) throw new Error("Only Function Component is supported");
          if (!path.node.declaration.id) throw new Error("Anonymous Function Component not supported");
          exportDefaultDeclarationName = path.node.declaration.id.name;
        }
      }
    }
  };
}

Object.defineProperty(exports, "__esModule", {
  value: !0
}), exports.default = index;
